#include <mem.h>
#include "heap.h"

extern hptr  HeapPtr;
extern struct  a_heap {
  uint   handle;
  ulong  size;
  hptr   ptr;
} *Heap;

void Hclear(void)
{
  if (HeapInitialized) {
    /* Clear all heap internal variables */
    memset(Heap, 0, (HeapMaxHandles+1)*sizeof(struct a_heap));

    /* Initialize variables */
    HeapPtr = HeapBase;
    *(ulong *)&HeapUnused += HeapUsed;
    *(ulong *)&HeapUsed = 0;
    *(uint *)&HeapUsedHandles = 0;
    HeapError = 0;
   }
  else
    HeapError = ERR_NOTINIT;
}
