#include <stddef.h>
#include "heap.h"

extern struct  a_heap {
  uint   handle;
  ulong  size;
  hptr   ptr;
} *Heap;

hptr Hpointer(uint handle)
{
  if (HeapInitialized) {
    --handle;                       /* Decrement handle for 0 based Heap[]  */
    if (handle >= 0 && handle < HeapMaxHandles &&
        (Heap[handle].ptr != NULL)) {
      HeapError = 0;
      return(Heap[handle].ptr);     /* Return handle pointer                */
     }
    else                            /* Handle not found or handle not valid */
      HeapError = ERR_HANDNOTFOUND;
   }
  else                              /* Heap not initialized                 */
    HeapError = ERR_NOTINIT;

  return(NULL);                     /* Return failure                       */
}
